$regfile = "m8def.dat"
$crystal = 1000000

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Pinc.3 , Db5 = Pinc.2 , Db6 = Pinc.1 , Db7 = Pinc.0 , E = Pinc.4 , Rs = Pinc.5
Cls

Config Portb = Input
Config Portb.7 = Output
Config Portd.0 = Output
Config Portd.1 = Output

Portb = &B01111111
Reset Portd

Enable Interrupts
Config Int0 = Rising
On Int0 , Przerwanie



Dim Licznik As Word
Dim Il_zwojow As Word
Dim Zwoj1 As Word
Dim Zwoj2 As Byte
Dim Zwoj3 As Byte
Dim Zwoj4 As Byte
Dim Lewy As Bit
Dim Prawy As Bit
Dim Srednica As Byte
Dim Dne1 As Byte
Dim Dne2 As Byte
Dim Menu As Byte

Enable Int0

Srednica = 0
Il_zwojow = 0
Licznik = 0

Lewy = 0
Prawy = 1
Zwoj1 = 0
Zwoj2 = 0
Zwoj3 = 0
Zwoj4 = 0
Dne1 = 0
Dne2 = 0

Do
Set Portd.1
Debounce Pinb.5 , 0 , Dalej
Loop
Dalej:
Reset Portd.1
Reset Portd.0

Menu = 11
Lcd "Il. zwojow: 0000"
Locate 1 , 13

Do

Debounce Pinb.5 , 0 , Gr_lewo , Sub
Debounce Pinb.6 , 0 , Gr_prawo , Sub
Debounce Pinb.4 , 0 , Motaj , Sub
Debounce Pinb.2 , 0 , Gora , Sub
Debounce Pinb.3 , 0 , Nast , Sub

Loop

Przerwanie:
Incr Licznik

Cls
Locate 1 , 1
Lcd "Docelowo: " ; Il_zwojow
Locate 2 , 1
Lcd "Nawinieto: " ; Licznik

If Prawy = 1 Then
   Set Portd.0
   Waitms Srednica
   Gosub Sprawdz
   Reset Portd.0
End If
If Lewy = 1 Then
   Set Portd.1
   Waitms Srednica
   Gosub Sprawdz
   Reset Portd.1
End If

If Licznik >= Il_zwojow Then
   Toggle Portb.7
   Cls
   Locate 1 , 1
   Lcd "Proces ukonczony"
   Locate 2 , 1
   Lcd "Nawinieto: " ; Licznik ; "zw"
   Wait 3
   Locate 1 , 1
   Cls
   Lcd "Jeszcze raz??"
   Do
      Delay
   Loop Until Pinb.4 = 0
   CONFIG WATCHDOG = 16
   Start Watchdog
   Do
      Delay
   loop
End If
Gosub Sprawdz
Return

Gr_lewo:
   Set Prawy
   Reset Lewy
Return

Gr_prawo:
   Set Lewy
   Reset Prawy
Return

Motaj:
Select Case Menu

   Case 11 To 14 :
      Menu = 21
      Cls
      Lcd "Sred. drut: 0.00"
      Locate 1 , 15
   Case 21 To 22 :
      Menu = 3

End Select

   If Menu = 3 Then
      Cursor Off
      Zwoj1 = Zwoj1 * 1000
      Il_zwojow = Zwoj2 * 100
      Zwoj3 = Zwoj3 * 10
      Il_zwojow = Il_zwojow + Zwoj3
      Il_zwojow = Il_zwojow + Zwoj1
      Il_zwojow = Il_zwojow + Zwoj4

      Dne1 = Dne1 * 10
      Srednica = Dne1 + Dne2
      Srednica = Srednica * 4

      Cls
      Locate 1 , 1
      Lcd "Docelowo: " ; Il_zwojow
      Locate 2 , 1
      Lcd "Nawinieto: " ; Licznik
      Menu = 4
   End If

   If Menu = 4 Then
      Toggle Portb.7
   End If

Return

Gora:
Select Case Menu

   Case 11 :
      If Zwoj1 = 9 Then
         Zwoj1 = 65535
      End If
      Cls
      Incr Zwoj1
      Locate 1 , 1
      Lcd "Il. zwojow: 0000"
      Locate 1 , 13
      Lcd Zwoj1
      Locate 1 , 14
      Lcd Zwoj2
      Locate 1 , 15
      Lcd Zwoj3
      Locate 1 , 16
      Lcd Zwoj4
      Locate 1 , 13
   Case 12 :
      If Zwoj2 = 9 Then
         Zwoj2 = 255
      End If
      Cls
      Incr Zwoj2
      Locate 1 , 1
      Lcd "Il. zwojow: 0000"
      Locate 1 , 13
      Lcd Zwoj1
      Locate 1 , 14
      Lcd Zwoj2
      Locate 1 , 15
      Lcd Zwoj3
      Locate 1 , 16
      Lcd Zwoj4
      Locate 1 , 14
   Case 13 :
      If Zwoj3 = 9 Then
         Zwoj3 = 255
      End If
      Cls
      Incr Zwoj3
      Locate 1 , 1
      Lcd "Il. zwojow: 0000"
      Locate 1 , 13
      Lcd Zwoj1
      Locate 1 , 14
      Lcd Zwoj2
      Locate 1 , 15
      Lcd Zwoj3
      Locate 1 , 16
      Lcd Zwoj4
      Locate 1 , 15
   Case 14 :
      If Zwoj4 = 9 Then
         Zwoj4 = 255
      End If
      Cls
      Incr Zwoj4
      Locate 1 , 1
      Lcd "Il. zwojow: 0000"
      Locate 1 , 13
      Lcd Zwoj1
      Locate 1 , 14
      Lcd Zwoj2
      Locate 1 , 15
      Lcd Zwoj3
      Locate 1 , 16
      Lcd Zwoj4
      Locate 1 , 16
   Case 21 :
      If Dne1 = 9 Then
         Dne1 = 255
      End If
      Cls
      Incr Dne1
      Locate 1 , 1
      Lcd "Sred. drut: 0.00"
      Locate 1 , 15
      Lcd Dne1
      Locate 1 , 16
      Lcd Dne2
      Locate 1 , 15
   Case 22 :
      If Dne2 = 9 Then
         Dne2 = 255
      End If
      Cls
      Incr Dne2
      Locate 1 , 1
      Lcd "Sred. drut: 0.00"
      Locate 1 , 15
      Lcd Dne1
      Locate 1 , 16
      Lcd Dne2
      Locate 1 , 16

End Select
Return

Nast:
Select Case Menu

   Case 11 :
      Menu = 12
      Locate 1 , 14
   Case 12 :
      Menu = 13
      Locate 1 , 15
   Case 13 :
      Menu = 14
      Locate 1 , 16
   Case 14 :
      Menu = 11
      Locate 1 , 13
   Case 21 :
      Menu = 22
      Locate 1 , 16
   Case 22 :
      Menu = 21
      Locate 1 , 15

End Select
Return

Sprawdz:
Debounce Pinb.5 , 0 , Gr_lewo , Sub
Debounce Pinb.6 , 0 , Gr_prawo , Sub
Debounce Pinb.4 , 0 , Motaj , Sub
Debounce Pinb.2 , 0 , Gora , Sub
Debounce Pinb.3 , 0 , Nast , Sub
Return

End